.NET
cancel
Showing results for 
Show  only  | Search instead for 
Did you mean: 

How to extrude imported dxf along polyline?

8 REPLIES 8
Reply
Message 1 of 9
awdas
1530 Views, 8 Replies

How to extrude imported dxf along polyline?

I have region is in external dxf file,

how to extrude it along polyline?

 

I can't get region after using dxfin method

 

                    Database myDxfDb = new Database(false, true);
                    myDxfDb.DxfIn(filename, logFilename);
                    Matrix3d dxfTrf = Matrix3d.Identity;
                    _ThisDatabase.Insert(dxfTrf, myDxfDb, true);
                    _ThisDatabase.UpdateExt(true);
                    myDxfDb.Dispose();
                    acTrans.Commit();

                    ObjectId id = AcUtils.EntLast();
                    Entity _ent = (Entity)acTrans.GetObject(id, OpenMode.ForWrite);

 

 

8 REPLIES 8
Message 2 of 9
Alfred.NESWADBA
in reply to: awdas

Hi,

 

look to the objecttype that is the result of inserting the DXF ==> is it a region or is it a block(definition/-reference....) 😉

 

- alfred -

------------------------------------------------------------------------------------
Alfred NESWADBA
Ingenieur Studio HOLLAUS ... www.hollaus.at ... blog.hollaus.at ... CDay 2024
------------------------------------------------------------------------------------
(not an Autodesk consultant)
Message 3 of 9
awdas
in reply to: Alfred.NESWADBA

dxf file contain only one region object

Message 4 of 9
Alfred.NESWADBA
in reply to: awdas

Hi,

 

and now try to insert this DXF into another drawing ==> what does it get then?

 

- alfred -

------------------------------------------------------------------------------------
Alfred NESWADBA
Ingenieur Studio HOLLAUS ... www.hollaus.at ... blog.hollaus.at ... CDay 2024
------------------------------------------------------------------------------------
(not an Autodesk consultant)
Message 5 of 9
awdas
in reply to: Alfred.NESWADBA

Hi alfred,

 

yes, I can that. dxf import as block reference.

 

well, how can I use this block reference 🙂

Message 6 of 9
Alfred.NESWADBA
in reply to: awdas

Hi,

 

either explode it or use the BlockTableRecord from this object to get the parts of this blockdefinition, there you also find then the region. You can then create an extrusion if this and add it to the database.

 

Good luck, -  alfred -

------------------------------------------------------------------------------------
Alfred NESWADBA
Ingenieur Studio HOLLAUS ... www.hollaus.at ... blog.hollaus.at ... CDay 2024
------------------------------------------------------------------------------------
(not an Autodesk consultant)
Message 7 of 9
Alfred.NESWADBA
in reply to: awdas

Hi,

 

and a sample for how to create 3D-solids from 2D-objects could be found >>>here<<< (and Kean Walmsley has a lot more interesting samples on his site)

 

- alfred -

------------------------------------------------------------------------------------
Alfred NESWADBA
Ingenieur Studio HOLLAUS ... www.hollaus.at ... blog.hollaus.at ... CDay 2024
------------------------------------------------------------------------------------
(not an Autodesk consultant)
Message 8 of 9
awdas
in reply to: Alfred.NESWADBA

thanks a lot for your interrest alfred,

 

but my problem is not extrude region. I cant get region from dxf file.

Message 9 of 9
awdas
in reply to: awdas

I found the solution

 

        public Entity ImportDxfAsEntity(string FileName, Point3d InsertionPoint, double Rotation = 0)
        {
            ObjectId blkid = ObjectId.Null;
            Entity ent = null;
            using (Database bdb = new Database(false, true))
            {
                bdb.DxfIn(FileName, @"c:\log.txt");
                //blkid = _ThisDatabase.Insert(System.IO.Path.GetFileNameWithoutExtension(FileName), bdb, true);
                blkid = _ThisDatabase.Insert("blok", bdb, true);
                using (Transaction tr = _ThisDatabase.TransactionManager.StartTransaction())
                {
                    BlockReference bref = new BlockReference(InsertionPoint, blkid);
                    using (BlockTableRecord btAttRec = (BlockTableRecord)bref.BlockTableRecord.GetObject(OpenMode.ForWrite))
                    {
                        foreach (ObjectId subid in btAttRec)
                        {
                            ent = (Entity)subid.GetObject(OpenMode.ForRead);
                        }
                    }
                    tr.Commit();
                }
            }
            return ent;
        }

 

 

Can't find what you're looking for? Ask the community or share your knowledge.

Post to forums  

Autodesk DevCon in Munich May 28-29th


Autodesk Design & Make Report

”Boost